<?php
class PVMVN_Cli{
	function __construct(){
		$passphrase = 'PVMVN-PublicGuessNetwork-cfca60269a1c2eef6b6ebbf4afcce0c3';
		$sql = new SQLite3('database.db', SQLITE3_OPEN_READWRITE, $passphrase);
		$this->db = $sql;
	}
	function GetAlgorithm($id){
		$algorithm = 
		[
			0 => "aes-128-cbc",
			1 => "aes-128-cbc-hmac-sha1",
			2 => "aes-128-cbc-hmac-sha256",
			3 => "aes-128-ccm",
			4 => "aes-128-cfb",
			5 => "aes-128-cfb1",
			6 => "aes-128-cfb8",
			7 => "aes-128-ctr",
			8 => "aes-128-gcm",
			9 => "aes-128-ocb",
			10 => "aes-128-ofb",
			11 => "aes-128-xts",
			12 => "aes-192-cbc",
			13 => "aes-192-ccm",
			14 => "aes-192-cfb",
			15 => "aes-192-cfb1",
			16 => "aes-192-cfb8",
			17 => "aes-192-ctr",
			18 => "aes-192-gcm",
			19 => "aes-192-ocb",
			20 => "aes-192-ofb",
			21 => "aes-256-cbc",
			22 => "aes-256-cbc-hmac-sha1",
			23 => "aes-256-cbc-hmac-sha256",
			24 => "aes-256-ccm",
			25 => "aes-256-cfb",
			26 => "aes-256-cfb1",
			27 => "aes-256-cfb8",
			28 => "aes-256-ctr",
			29 => "aes-256-gcm",
			30 => "aes-256-ocb",
			31 => "aes-256-ofb",
			32 => "aes-256-xts",
			33 => "aes-128-ecb"
		];
		if(isset($algorithm[$id]))
			return $algorithm[$id];
		else
			return $algorithm[0];
	}
	function unpackData($data){
		$method = unpack('i', substr($data,0,4))[1];
		$auid = unpack('i', substr($data,4,4))[1];
		$length = unpack('i', substr($data,8,4))[1];
		$Authlength = unpack('i', substr($data,12,4))[1];
		$algorithm = unpack('i', substr($data,16,4))[1];
		$authData = substr($data, 20, $Authlength);
		$PacketData = substr($data,(20 + $Authlength), $length);
		return ['method' => $method, 'auid' => $auid, 'algorithm' => $this->GetAlgorithm($algorithm), 'auth' => $authData, 'data' => $PacketData];
	}
	function auth($username, $password){
		$db = $this->db;
		$username = $this->repString($username);
		$password = sha1($password);
		$query = $db->query("SELECT * FROM `Accounts` WHERE `username` = '$username' && `password` = '$password'");
		if($query)
			return true;
		else
			return false;
	}
	function getKey($auid){
		$db = $this->db;
		$query = $db->query("SELECT * FROM `key` WHERE `auid` = $auid");
		if($query)
			return $query->fetchArray()["key"];
		else
			return false;
	}
	function decryptData($data, $key, $algorithm){
		return
			openssl_decrypt(
				base64_encode($data), 
				$algorithm,
				$key
			);
	}
	function encryptData($data, $key, $algorithm){
		return
			base64_decode(
				openssl_encrypt(
					$data, 
					$algorithm,
					$key
				)
			);
	}
	function POST($url, $data = [])
	{
		$options = 
		[
			CURLOPT_CONNECTTIMEOUT	=> 600,
			CURLOPT_TIMEOUT			=> 600,
			CURLOPT_HEADER			=> false,
			CURLOPT_FOLLOWLOCATION	=> true,
			CURLOPT_RETURNTRANSFER	=> true,
			CURLOPT_USERAGENT		=> "PVM-VirtualNetworl-Bridge-Connection",
			CURLOPT_POSTFIELDS		=> $data,
			CURLOPT_SSL_VERIFYPEER	=> false
		];
		$ch = curl_init($url);
		curl_setopt_array($ch, $options);
		$content = curl_exec($ch);
		curl_close($ch);
		return $content;
	}
	function GET($url)
	{
		$options = 
		[
			CURLOPT_CONNECTTIMEOUT		=> 600,
			CURLOPT_TIMEOUT				=> 600,
			CURLOPT_HEADER				=> false,
			CURLOPT_CUSTOMREQUEST		=> "GET",
			CURLOPT_FOLLOWLOCATION		=> true,
			CURLOPT_RETURNTRANSFER		=> true,
			CURLOPT_USERAGENT			=> "PVM-VirtualNetworl-Bridge-Connection",
			CURLOPT_SSL_VERIFYPEER		=> false
		];
		$ch = curl_init($url);
		curl_setopt_array($ch, $options);
		$content = curl_exec($ch);
		curl_close($ch);
		return $content;
	}
	private function repString($string){
		return str_replace(['"',"'"],['\\"', "\\'"],$string);
	}
}
header("Content-Type: text/plain");
if(isset($_POST['data'])){
	$pvmvn = new PVMVN_Cli();
	$unpack = $pvmvn->unpackData($_POST['data']);
	if(empty($unpack['method']) && !is_numeric($unpack['method']))
		die("ERROR_DATA_0");
	if(empty($unpack['algorithm']))
		die("ERROR_DATA_1");
	if(empty($unpack['auth']))
		die("ERROR_DATA_2");
	if(empty($unpack['data']))
		die("ERROR_DATA_3");
	if(empty($unpack['auid']) && !is_numeric($unpack['auid']))
		die("ERROR_DATA_4");
	$key = $pvmvn->getKey($unpack['auid']);
	if(empty($key))
		die("INVALID_AUID");
	$authData = @$pvmvn->decryptData($unpack['auth'], $key, $unpack['algorithm']);
	if(empty($authData))
		die("AUTH_FAILED_0");
	$JsonAuthData = @json_decode($authData, true);
	if(!isset($JsonAuthData["username"]))
		die("AUTH_FAILED_1");
	$data = @$pvmvn->decryptData($unpack['data'], $key, $unpack['algorithm']);
	if(!$data)
		die("ERROR_DATA_5");
	$Jsondata = @json_decode($data, true);
	if(!is_array($Jsondata))
		die("ERROR_DATA_6");
	$auth = $pvmvn->auth($JsonAuthData["username"], $JsonAuthData["password"]);
	if(!$auth)
		die("AUTH_FAILED_2");
	if($unpack['method'] == 0){
		$output = $pvmvn->encryptData($pvmvn->GET($JsonAuthData["url"]), $key, $unpack['algorithm']);
	}else{
		$output = $pvmvn->encryptData($pvmvn->POST($JsonAuthData["url"], $Jsondata), $key, $unpack['algorithm']);
	}
	header("Content-Length: ".strlen($output));
	echo $output;
}
?>
?>